<a id="mypy-boto3-sqs"></a>

# mypy-boto3-sqs

[![PyPI - types-aiobotocore-sqs](https://img.shields.io/pypi/v/types-aiobotocore-sqs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sqs)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-sqs.svg?color=blue)](https://pypi.org/project/types-aiobotocore-sqs)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-sqs?color=blue)](https://pypistats.org/packages/types-aiobotocore-sqs)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.SQS 1.20.54](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/sqs.html#SQS)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.0.4](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-sqs docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sqs/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-sqs](#mypy-boto3-sqs)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
    - [From conda-forge](#from-conda-forge)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
- [Explicit type annotations are optional here](#explicit-type-annotations-are-optional-here)
- [Type should be correctly discovered by mypy and IDEs](#type-should-be-correctly-discovered-by-mypy-and-ides)
- [Explicit type annotations are optional here](#explicit-type-annotations-are-optional-here)
- [Type should be correctly discovered by mypy and IDEs](#type-should-be-correctly-discovered-by-mypy-and-ides)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `SQS`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `SQS` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[sqs]'

# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[sqs]'

# standalone installation
python -m pip install types-aiobotocore-sqs
```

<a id="from-conda-forge"></a>

### From conda-forge

Installing `types-aiobotocore-sqs` from the `conda-forge` channel can be
achieved by adding `conda-forge` to your channels with:

```bash
conda config --add channels conda-forge
conda config --set channel_priority strict
```

Once the `conda-forge` channel has been enabled, `types-aiobotocore-sqs` can be
installed with:

```bash
conda install types-aiobotocore-sqs
```

It is possible to list all of the versions of `types-aiobotocore-sqs` available
on your platform with:

```bash
conda search types-aiobotocore-sqs --channel conda-forge
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-sqs
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[sqs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[sqs]'
```

Both type checking and auto-complete should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[sqs]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[sqs]'`
```

Both type checking and auto-complete should now work. Explicit type annotations
**are required**. Use `types-aiobotocore` package instead for implicit type
discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[sqs]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[sqs]` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[sqs]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[sqs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[sqs]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[sqs]` in your environment:

```bash
python -m pip install 'types-aiobotocore[sqs]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SQSClient` provides annotations for `session.create_client("sqs")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSClient

session = get_session()
async with session.create_client("sqs") as client:
    client: SQSClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_sqs.paginator` module contains type annotations for all
paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSClient
from types_aiobotocore_sqs.paginator import (
    ListDeadLetterSourceQueuesPaginator,
    ListQueuesPaginator,
)

session = get_session()
async with session.create_client("sqs") as client:
    client: SQSClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_dead_letter_source_queues_paginator: ListDeadLetterSourceQueuesPaginator = client.get_paginator("list_dead_letter_source_queues")
        list_queues_paginator: ListQueuesPaginator = client.get_paginator("list_queues")
    ```




### Service Resource annotations

`SQSServiceResource` provides annotations for `aiobotocore.resource("sqs")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource
    # now resource usage is checked by mypy and IDE should provide code auto-complete
````

### Other resources annotations

`types_aiobotocore_sqs.service_resource` module contains type annotations for
all resources.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource
from types_aiobotocore_sqs.service_resource import (
    Message,
    Queue,
)

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource

<a id="explicit-type-annotations-are-optional-here"></a>

# Explicit type annotations are optional here
<a id="type-should-be-correctly-discovered-by-mypy-and-ides"></a>

# Type should be correctly discovered by mypy and IDEs
    my_message: Message = resource.Message(...)
    my_queue: Queue = resource.Queue(...)
```

### Collections annotations

`types_aiobotocore_sqs.service_resource` module contains type annotations for
all `SQSServiceResource` collections.

```python
from aiobotocore.session import get_session

from types_aiobotocore_sqs import SQSServiceResource
from types_aiobotocore_sqs.service_resource import (
    ServiceResourceQueuesCollection,
)

session = get_session()
async with session.resource("sqs") as resource:
    resource: SQSServiceResource

<a id="explicit-type-annotations-are-optional-here"></a>

# Explicit type annotations are optional here
<a id="type-should-be-correctly-discovered-by-mypy-and-ides"></a>

# Type should be correctly discovered by mypy and IDEs
    queues: sqs_resources.ServiceResourceQueuesCollection = resource.queues
```

### Literals

`types_aiobotocore_sqs.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_sqs.literals import (
    ListDeadLetterSourceQueuesPaginatorName,
    ListQueuesPaginatorName,
    MessageSystemAttributeNameForSendsType,
    MessageSystemAttributeNameType,
    QueueAttributeNameType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ListDeadLetterSourceQueuesPaginatorName) -> bool:
    ...
```

### Typed dictionaries

`types_aiobotocore_sqs.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_sqs.type_defs import (
    AddPermissionRequestQueueTypeDef,
    AddPermissionRequestRequestTypeDef,
    BatchResultErrorEntryTypeDef,
    ChangeMessageVisibilityBatchRequestEntryTypeDef,
    ChangeMessageVisibilityBatchRequestQueueTypeDef,
    ChangeMessageVisibilityBatchRequestRequestTypeDef,
    ChangeMessageVisibilityBatchResultEntryTypeDef,
    ChangeMessageVisibilityBatchResultTypeDef,
    ChangeMessageVisibilityRequestMessageTypeDef,
    ChangeMessageVisibilityRequestRequestTypeDef,
    CreateQueueRequestRequestTypeDef,
    CreateQueueRequestServiceResourceTypeDef,
    CreateQueueResultTypeDef,
    DeleteMessageBatchRequestEntryTypeDef,
    DeleteMessageBatchRequestQueueTypeDef,
    DeleteMessageBatchRequestRequestTypeDef,
    DeleteMessageBatchResultEntryTypeDef,
    DeleteMessageBatchResultTypeDef,
    DeleteMessageRequestRequestTypeDef,
    DeleteQueueRequestRequestTypeDef,
    GetQueueAttributesRequestRequestTypeDef,
    GetQueueAttributesResultTypeDef,
    GetQueueUrlRequestRequestTypeDef,
    GetQueueUrlRequestServiceResourceTypeDef,
    GetQueueUrlResultTypeDef,
    ListDeadLetterSourceQueuesRequestRequestTypeDef,
    ListDeadLetterSourceQueuesResultTypeDef,
    ListQueueTagsRequestRequestTypeDef,
    ListQueueTagsResultTypeDef,
    ListQueuesRequestRequestTypeDef,
    ListQueuesResultTypeDef,
    MessageAttributeValueTypeDef,
    MessageSystemAttributeValueTypeDef,
    MessageTypeDef,
    PaginatorConfigTypeDef,
    PurgeQueueRequestRequestTypeDef,
    QueueMessageRequestTypeDef,
    ReceiveMessageRequestQueueTypeDef,
    ReceiveMessageRequestRequestTypeDef,
    ReceiveMessageResultTypeDef,
    RemovePermissionRequestQueueTypeDef,
    RemovePermissionRequestRequestTypeDef,
    ResponseMetadataTypeDef,
    SendMessageBatchRequestEntryTypeDef,
    SendMessageBatchRequestQueueTypeDef,
    SendMessageBatchRequestRequestTypeDef,
    SendMessageBatchResultEntryTypeDef,
    SendMessageBatchResultTypeDef,
    SendMessageRequestQueueTypeDef,
    SendMessageRequestRequestTypeDef,
    SendMessageResultTypeDef,
    ServiceResourceMessageRequestTypeDef,
    ServiceResourceQueueRequestTypeDef,
    SetQueueAttributesRequestQueueTypeDef,
    SetQueueAttributesRequestRequestTypeDef,
    TagQueueRequestRequestTypeDef,
    UntagQueueRequestRequestTypeDef,
)

def get_structure() -> AddPermissionRequestQueueTypeDef:
    return {
      ...
    }
```

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers a drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from the documentation (blame `botocore` docs if types
  are incorrect).
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

## What's new

### Implemented features

- Fully type annotated `boto3`, `botocore` and `aiobotocore` libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.session` calls
- Auto discovery of types for `session.client` and `session.session` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/vemel/mypy_boto3_builder/releases).

## Versioning

`types-aiobotocore-sqs` version is the same as related `aiobotocore` version
and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_sqs/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
